// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"

#pragma comment(lib, "AztecFont.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern "C" __declspec(dllimport) void _stdcall AztecEncode(LPCTSTR Message, WORD Mode, WORD CorrectionLevel, WORD PreferredFormat, BOOL HandleTilde, BOOL StructuredAppend);
extern "C" __declspec(dllimport) WORD _stdcall AztecGetRows();
extern "C" __declspec(dllimport) WORD _stdcall AztecGetCols();
extern "C" __declspec(dllimport) void _stdcall AztecSetStructuredAppend(WORD SymbolID, WORD SymbolCount);
extern "C" __declspec(dllimport) WORD _stdcall AztecGetCharAt(WORD RowIndex, WORD ColIndex);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_COMBO3, m_cbxFontSize);
	DDX_Control(pDX, IDC_EDIT6, m_txtSymbolCount);
	DDX_Control(pDX, IDC_EDIT5, m_txtSymbolID);
	DDX_Control(pDX, IDC_CHECK2, m_chkSA);
	DDX_Control(pDX, IDC_EDIT3, m_txtECLevel);
	DDX_Control(pDX, IDC_CHECK1, m_chkHandleTilde);
	DDX_Control(pDX, IDC_COMBO2, m_cbxPreferredFormat);
	DDX_Control(pDX, IDC_COMBO1, m_cbxMode);
	DDX_Control(pDX, IDC_EDIT2, m_txtMessage);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PRINT, OnPrint)
	ON_BN_CLICKED(IDC_CHECK2, OnCheckSA)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	m_txtMessage.SetWindowText("1234");
	m_cbxMode.SetCurSel(0);
	m_cbxPreferredFormat.SetCurSel(0);
	m_chkHandleTilde.SetCheck(false);
	m_txtECLevel.SetWindowText("23");
	m_chkSA.SetCheck(false);
	m_txtSymbolID.SetWindowText("1");
	m_txtSymbolID.SetReadOnly(true);
	m_txtSymbolCount.SetWindowText("26");
	m_txtSymbolCount.SetReadOnly(true);
	m_cbxFontSize.SetCurSel(4);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemoDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CDemoDlg::OnPrint() 
{
	// TODO: Add your control notification handler code here
	
	GetAllValues();

	if (m_StructuredAppend) 
		AztecSetStructuredAppend(m_SymbolID, m_SymbolCount);
	    
	AztecEncode(m_Message, m_Mode, m_CorrectionLevel, m_PreferredFormat, m_HandleTilde, m_StructuredAppend);

	// how many rows?
	int RowCount = AztecGetRows();

	// how many characters in one row?
	int ColCount = AztecGetCols();

	HDC hPrinterDC;

    // get Print Dialog
	CPrintDialog *printerDlg = new CPrintDialog(FALSE, PD_ALLPAGES | PD_RETURNDC, NULL);

    // do initialization
	printerDlg->m_pd.nFromPage = printerDlg->m_pd.nToPage = 1;
    printerDlg->m_pd.nMinPage = printerDlg->m_pd.nMaxPage = 1;
   
    // show printer dialog.
    printerDlg->DoModal();

    // get the handle of printer.
    hPrinterDC = printerDlg->GetPrinterDC();

	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	lf.lfHeight = m_FontSize * GetDeviceCaps(hPrinterDC, LOGPIXELSY) / 72;
	lf.lfCharSet = ANSI_CHARSET;
	lf.lfOutPrecision = OUT_DEFAULT_PRECIS;
	lf.lfClipPrecision = OUT_DEFAULT_PRECIS;
	lf.lfQuality = DRAFT_QUALITY;
	strcpy(lf.lfFaceName, "MW6 Matrix");

	CFont newFont;
	newFont.CreateFontIndirect(&lf);

    if (hPrinterDC != NULL)
    {
		CDC *pDC = new CDC;
		// attach printer DC
        pDC->Attach(hPrinterDC);

		// start a new print job
        pDC->StartDoc("print Aztec barcode using Matrix Font");  
                                 
		// start a new page
        pDC->StartPage();

		CFont *oldFont = pDC->SelectObject(&newFont);

		char *OneLine = new char[ColCount + 1];
		long index = 0;
		for (int i = 0; i < RowCount; i++) {
			for (int j = 0; j < ColCount; j++) {
				OneLine[j] = (char)AztecGetCharAt(i, j);
			}
			OneLine[ColCount] = '\0';

			// print one line using Aztec font
			pDC->TextOut(300, 400 + i*lf.lfHeight, OneLine);
		}
		delete [] OneLine;

		pDC->SelectObject(oldFont);

		// end current page
        pDC->EndPage();            

		// end current print job
        pDC->EndDoc();    
		
		// detach the printer DC
        pDC->Detach();
		
        delete pDC;
	}

    delete printerDlg;
}

void CDemoDlg::OnCheckSA() 
{
	// TODO: Add your control notification handler code here
	if (m_chkSA.GetCheck() == BST_CHECKED) {
		m_txtSymbolID.SetReadOnly(false);
		m_txtSymbolCount.SetReadOnly(false);
	}
	else {
		m_txtSymbolID.SetReadOnly(true);
		m_txtSymbolCount.SetReadOnly(true);
	}
}

void CDemoDlg::GetAllValues()
{
	CString tmp;

	// Message
	m_txtMessage.GetWindowText(m_Message);
	
	// Mode
	m_Mode = m_cbxMode.GetCurSel();
	
	// Preferred format
	m_PreferredFormat = m_cbxPreferredFormat.GetCurSel();
	
	// Process tilde?
	m_HandleTilde = m_chkHandleTilde.GetCheck();
	
	// Error correction level
	m_txtECLevel.GetWindowText(tmp);
	m_CorrectionLevel = (WORD)strtol(tmp, 0, 10);

	// Allow structure append
	m_StructuredAppend = m_chkSA.GetCheck();

	// Current symbol ID
	m_txtSymbolID.GetWindowText(tmp);
	m_SymbolID = (WORD)strtol(tmp, 0, 10);
	
	// Total symbols
	m_txtSymbolCount.GetWindowText(tmp);
	m_SymbolCount = (WORD)strtol(tmp, 0, 10);

	// Font size
	m_cbxFontSize.GetWindowText(tmp);
	m_FontSize = (WORD)strtol(tmp, 0, 10);
}
