VERSION 5.00
Begin VB.Form frmDemo 
   Caption         =   "MW6 Aztec Font Demo"
   ClientHeight    =   7665
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9120
   LinkTopic       =   "Form1"
   ScaleHeight     =   7665
   ScaleWidth      =   9120
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtSymbolCount 
      Height          =   315
      Left            =   1680
      TabIndex        =   7
      Text            =   "26"
      Top             =   3240
      Width           =   855
   End
   Begin VB.TextBox txtSymbolID 
      Height          =   315
      Left            =   1680
      TabIndex        =   6
      Text            =   "1"
      Top             =   2814
      Width           =   855
   End
   Begin VB.CheckBox chkSA 
      Alignment       =   1  'Right Justify
      Caption         =   "Allow Structure Append"
      Height          =   375
      Left            =   240
      TabIndex        =   5
      Top             =   2330
      Width           =   1695
   End
   Begin VB.TextBox txtECLevel 
      Height          =   375
      Left            =   1680
      TabIndex        =   4
      Text            =   "23"
      Top             =   1846
      Width           =   1575
   End
   Begin VB.ComboBox cbxFontSize 
      Height          =   315
      ItemData        =   "frmDemo.frx":0000
      Left            =   1680
      List            =   "frmDemo.frx":0022
      TabIndex        =   8
      Top             =   3650
      Width           =   1575
   End
   Begin VB.CheckBox chkHandleTilde 
      Alignment       =   1  'Right Justify
      Caption         =   "Process Tilde"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   1482
      Width           =   1695
   End
   Begin VB.ComboBox cbxPreferredFormat 
      Height          =   315
      ItemData        =   "frmDemo.frx":004C
      Left            =   1680
      List            =   "frmDemo.frx":00BF
      TabIndex        =   2
      Top             =   1058
      Width           =   2415
   End
   Begin VB.ComboBox cbxMode 
      Height          =   315
      ItemData        =   "frmDemo.frx":0312
      Left            =   1680
      List            =   "frmDemo.frx":031C
      TabIndex        =   1
      Top             =   634
      Width           =   2415
   End
   Begin VB.TextBox txtMessage 
      Height          =   285
      Left            =   1680
      TabIndex        =   0
      Text            =   "1234"
      Top             =   240
      Width           =   4575
   End
   Begin VB.CommandButton cmdPrint 
      Caption         =   "Print Aztec"
      Height          =   495
      Left            =   7080
      TabIndex        =   10
      Top             =   1620
      Width           =   1695
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   7080
      TabIndex        =   11
      Top             =   3000
      Width           =   1695
   End
   Begin VB.CommandButton cmdDisplay 
      Caption         =   "Display Aztec"
      Height          =   495
      Left            =   7080
      TabIndex        =   9
      Top             =   240
      Width           =   1695
   End
   Begin VB.TextBox txtAztec 
      Alignment       =   2  'Center
      Height          =   3255
      Left            =   240
      MultiLine       =   -1  'True
      TabIndex        =   12
      Top             =   4080
      Width           =   8655
   End
   Begin VB.Label Label3 
      Caption         =   "Total Symbols"
      Height          =   255
      Left            =   240
      TabIndex        =   19
      Top             =   3210
      Width           =   1095
   End
   Begin VB.Label Label2 
      Caption         =   "Current Symbol ID"
      Height          =   255
      Left            =   240
      TabIndex        =   18
      Top             =   2820
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Error Correction Level (5% - 95%)"
      Height          =   375
      Left            =   240
      TabIndex        =   17
      Top             =   1800
      Width           =   1335
   End
   Begin VB.Label lblFontSize 
      Caption         =   "Font Size"
      Height          =   255
      Left            =   240
      TabIndex        =   16
      Top             =   3600
      Width           =   1095
   End
   Begin VB.Label lblPreferredFormat 
      Caption         =   "Preferred Format"
      Height          =   255
      Left            =   240
      TabIndex        =   15
      Top             =   1020
      Width           =   1335
   End
   Begin VB.Label lblMode 
      Caption         =   "Mode"
      Height          =   255
      Left            =   240
      TabIndex        =   14
      Top             =   630
      Width           =   855
   End
   Begin VB.Label lblMessage 
      Caption         =   "Message"
      Height          =   255
      Left            =   240
      TabIndex        =   13
      Top             =   240
      Width           =   735
   End
End
Attribute VB_Name = "frmDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Sub AztecEncode Lib "AztecFont.dll" _
(ByVal Message As String, ByVal Mode As Integer, ByVal CorrectionLevel As Integer, _
 ByVal PreferredFormat As Integer, ByVal HandleTilde As Boolean, ByVal StructuredAppend As Boolean)

Private Declare Function AztecGetRows Lib "AztecFont.dll" () As Integer
Private Declare Function AztecGetCols Lib "AztecFont.dll" () As Integer
Private Declare Function AztecGetCharAt Lib "AztecFont.dll" (ByVal RowIndex As Integer, ByVal ColIndex As Integer) As Integer
Private Declare Sub AztecSetStructuredAppend Lib "AztecFont.dll" (ByVal SymbolID As Integer, ByVal SymbolCount As Integer)

Private Message As String
Private Mode As Integer
Private PreferredFormat As Integer
Private CorrectionLevel As Integer
Private HandleTilde As Boolean
Private StructuredAppend As Boolean
Private SymbolID As Integer
Private SymbolCount As Integer

Private Sub cmdDisplay_Click()
    Dim RowCount As Integer
    Dim ColCount As Integer

    On Error GoTo ErrorHandler
    
    If (Not GetValues()) Then
        Exit Sub
    End If
    
    If (StructuredAppend) Then
        ' Add structured append information
        Call AztecSetStructuredAppend(SymbolID, SymbolCount)
    End If
    
    ' Encode data using Aztec
    Call AztecEncode(Message, Mode, CorrectionLevel, PreferredFormat, HandleTilde, StructuredAppend)

    txtAztec.Text = ""
    txtAztec.FontName = "MW6 Matrix"
    txtAztec.FontSize = CInt(cbxFontSize.Text)
    
    ' How many rows?
    RowCount = AztecGetRows
    
    ' How many characters in one row?
    ColCount = AztecGetCols
    
    ' Produce string for Aztec font
    EncodedMsg = vbCrLf
    For I = 1 To RowCount
        For J = 1 To ColCount
            EncodedMsg = EncodedMsg & Chr(AztecGetCharAt(I - 1, J - 1))
        Next J
        EncodedMsg = EncodedMsg & vbCrLf
    Next I
    txtAztec.Text = EncodedMsg
    
    Exit Sub
    
ErrorHandler:

End Sub

Private Sub cmdPrint_Click()
    Dim RowCount As Integer
    Dim ColCount As Integer

    On Error GoTo ErrorHandler
    
    If (Not GetValues()) Then
        Exit Sub
    End If
    
    If (StructuredAppend) Then
        ' Add structured append information
        Call AztecSetStructuredAppend(SymbolID, SymbolCount)
    End If
    
    ' Encode data using Aztec
    Call AztecEncode(Message, Mode, CorrectionLevel, PreferredFormat, HandleTilde, StructuredAppend)

    Printer.FontName = "MW6 Matrix"
    Printer.FontSize = CInt(cbxFontSize.Text)
    
    ' Produce string for Aztec font
    Printer.CurrentX = 600
    Printer.CurrentY = 800
    
    ' How many rows?
    RowCount = AztecGetRows
    
    ' How many characters in one row?
    ColCount = AztecGetCols
    
    ' Print all rows using Aztec font
    For I = 1 To RowCount
        OneLine = ""
        For J = 1 To ColCount
            OneLine = OneLine & Chr(AztecGetCharAt(I - 1, J - 1))
        Next J
        ' Print one line using Aztec font
        Printer.Print OneLine
        Printer.CurrentX = 600
    Next I
    Printer.EndDoc
    
    Exit Sub
    
ErrorHandler:

End Sub

Private Function GetValues() As Boolean
    Dim ErrorMsg As String
    
    On Error GoTo HandleError
    
    Message = txtMessage.Text
    PreferredFormat = cbxPreferredFormat.ListIndex
    Mode = cbxMode.ListIndex
    HandleTilde = chkHandleTilde.Value
    StructuredAppend = chkSA.Value
    CorrectionLevel = CInt(txtECLevel.Text)
    If (StructuredAppend) Then
        SymbolID = CInt(txtSymbolID.Text)
        SymbolCount = CInt(txtSymbolCount.Text)
    End If
    
    ErrorMsg = ""
    If (SymbolCount > 26) Then
        ErrorMsg = "The value of symbol count must be between 1 and 26." & vbCrLf
    End If
    
    If (SymbolID > SymbolCount) Then
        ErrorMsg = ErrorMsg & "The value of current symbol ID must be less than or equal to the value of symbol count."
    End If
    
    If (Len(ErrorMsg)) Then
        MsgBox ErrorMsg
        GetValues = False
        Exit Function
    End If
    
    GetValues = True
    Exit Function
    
HandleError:
    MsgBox "Data format is not valid."
    GetValues = False
End Function

Private Sub Form_Load()
    cbxPreferredFormat.ListIndex = 0
    cbxFontSize.ListIndex = 6
    cbxMode.ListIndex = 0
End Sub

Private Sub cmdExit_Click()
    Unload Me
End Sub
