using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Demo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmDemo : System.Windows.Forms.Form
	{
		private MW6Aztec.Font AztecFontObj = new MW6Aztec.Font();
		private System.Drawing.Printing.PrintDocument printDocument1;
		internal System.Drawing.Printing.PrintDocument printDocument2;
		internal System.Drawing.Printing.PrintDocument printDocument3;
		internal System.Drawing.Printing.PrintDocument printDocument4;
		internal System.Windows.Forms.Button btnExit;
		internal System.Windows.Forms.Button btnDisplay;
		internal System.Windows.Forms.TextBox txtMessage;
		internal System.Windows.Forms.Label lblMessage;
		internal System.Windows.Forms.Button btnPrint;
		internal System.Windows.Forms.ComboBox cbxFontSize;
		internal System.Windows.Forms.Label lblFontSize;
		internal System.Windows.Forms.TextBox txtAztec;
		internal System.Windows.Forms.ComboBox cbxPreferredFormat;
		internal System.Windows.Forms.Label lblMode;
		private System.Windows.Forms.CheckBox chkHandleTilde;
		private System.Windows.Forms.Label lblECLevel;
		private System.Windows.Forms.CheckBox chkSA;
		private System.Windows.Forms.TextBox txtECLevel;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtSymbolID;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox txtSymbolCount;
		internal System.Windows.Forms.Label lblPF;
		internal System.Windows.Forms.ComboBox cbxMode;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmDemo()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.printDocument1 = new System.Drawing.Printing.PrintDocument();
			this.cbxPreferredFormat = new System.Windows.Forms.ComboBox();
			this.printDocument2 = new System.Drawing.Printing.PrintDocument();
			this.lblPF = new System.Windows.Forms.Label();
			this.cbxMode = new System.Windows.Forms.ComboBox();
			this.txtAztec = new System.Windows.Forms.TextBox();
			this.printDocument3 = new System.Drawing.Printing.PrintDocument();
			this.printDocument4 = new System.Drawing.Printing.PrintDocument();
			this.btnExit = new System.Windows.Forms.Button();
			this.btnDisplay = new System.Windows.Forms.Button();
			this.txtMessage = new System.Windows.Forms.TextBox();
			this.lblMessage = new System.Windows.Forms.Label();
			this.btnPrint = new System.Windows.Forms.Button();
			this.cbxFontSize = new System.Windows.Forms.ComboBox();
			this.lblFontSize = new System.Windows.Forms.Label();
			this.lblMode = new System.Windows.Forms.Label();
			this.chkHandleTilde = new System.Windows.Forms.CheckBox();
			this.lblECLevel = new System.Windows.Forms.Label();
			this.chkSA = new System.Windows.Forms.CheckBox();
			this.txtECLevel = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.txtSymbolID = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.txtSymbolCount = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// printDocument1
			// 
			this.printDocument1.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.printDocument1_PrintPage);
			// 
			// cbxPreferredFormat
			// 
			this.cbxPreferredFormat.Items.AddRange(new object[] {
																	"0 - Auto",
																	"1 - 15 X 15 compact format",
																	"2 - 19 X 19",
																	"3 - 19 X 19 compact format",
																	"4 - 23 X 23",
																	"5 - 23 X 23 compact format",
																	"6 - 27 X 27",
																	"7 - 27 X 27 compact format",
																	"8 - 31 X 31",
																	"9 - 37 X 37",
																	"10 - 41 X 41",
																	"11 - 45 X 45",
																	"12 - 49 X 49",
																	"13 - 53 X 53",
																	"14 - 57 X 57",
																	"15 - 61 X 61",
																	"16 - 67 X 67",
																	"17 - 71 X 71",
																	"18 - 75 X 75",
																	"19 - 79 X 79",
																	"20 - 83 X 83",
																	"21 - 87 X 87",
																	"22 - 91 X 91",
																	"23 - 95 X 95",
																	"24 - 101 X 101",
																	"25 - 105 X 105",
																	"26 - 109 X 109",
																	"27 - 113 X 113",
																	"28 - 117 X 117",
																	"29 - 121 X 121",
																	"30 - 125 X 125",
																	"31 - 131 X 131",
																	"32 - 135 X 135",
																	"33 - 139 X 139",
																	"34 - 143 X 143",
																	"35 - 147 X 147",
																	"36 - 151 X 151"});
			this.cbxPreferredFormat.Location = new System.Drawing.Point(144, 40);
			this.cbxPreferredFormat.Name = "cbxPreferredFormat";
			this.cbxPreferredFormat.Size = new System.Drawing.Size(112, 21);
			this.cbxPreferredFormat.TabIndex = 1;
			// 
			// lblPF
			// 
			this.lblPF.Location = new System.Drawing.Point(13, 41);
			this.lblPF.Name = "lblPF";
			this.lblPF.Size = new System.Drawing.Size(96, 20);
			this.lblPF.TabIndex = 54;
			this.lblPF.Text = "Preferred Format";
			// 
			// cbxMode
			// 
			this.cbxMode.Items.AddRange(new object[] {
														 "0 - Auto",
														 "1 - Binary"});
			this.cbxMode.Location = new System.Drawing.Point(144, 70);
			this.cbxMode.Name = "cbxMode";
			this.cbxMode.Size = new System.Drawing.Size(112, 21);
			this.cbxMode.TabIndex = 2;
			// 
			// txtAztec
			// 
			this.txtAztec.Location = new System.Drawing.Point(16, 288);
			this.txtAztec.Multiline = true;
			this.txtAztec.Name = "txtAztec";
			this.txtAztec.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.txtAztec.Size = new System.Drawing.Size(396, 128);
			this.txtAztec.TabIndex = 12;
			this.txtAztec.Text = "";
			this.txtAztec.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// btnExit
			// 
			this.btnExit.Location = new System.Drawing.Point(296, 207);
			this.btnExit.Name = "btnExit";
			this.btnExit.Size = new System.Drawing.Size(112, 33);
			this.btnExit.TabIndex = 11;
			this.btnExit.Text = "Exit";
			this.btnExit.Click += new System.EventHandler(this.btnExit_Click);
			// 
			// btnDisplay
			// 
			this.btnDisplay.Location = new System.Drawing.Point(296, 55);
			this.btnDisplay.Name = "btnDisplay";
			this.btnDisplay.Size = new System.Drawing.Size(112, 33);
			this.btnDisplay.TabIndex = 9;
			this.btnDisplay.Text = "Display Aztec";
			this.btnDisplay.Click += new System.EventHandler(this.btnDisplay_Click);
			// 
			// txtMessage
			// 
			this.txtMessage.Location = new System.Drawing.Point(144, 11);
			this.txtMessage.Name = "txtMessage";
			this.txtMessage.Size = new System.Drawing.Size(264, 20);
			this.txtMessage.TabIndex = 0;
			this.txtMessage.Text = "1234";
			// 
			// lblMessage
			// 
			this.lblMessage.Location = new System.Drawing.Point(13, 11);
			this.lblMessage.Name = "lblMessage";
			this.lblMessage.Size = new System.Drawing.Size(64, 20);
			this.lblMessage.TabIndex = 51;
			this.lblMessage.Text = "Message";
			// 
			// btnPrint
			// 
			this.btnPrint.Location = new System.Drawing.Point(296, 131);
			this.btnPrint.Name = "btnPrint";
			this.btnPrint.Size = new System.Drawing.Size(112, 33);
			this.btnPrint.TabIndex = 10;
			this.btnPrint.Text = "Print Aztec";
			this.btnPrint.Click += new System.EventHandler(this.btnPrint_Click);
			// 
			// cbxFontSize
			// 
			this.cbxFontSize.Items.AddRange(new object[] {
															 "8",
															 "9",
															 "10",
															 "11",
															 "12",
															 "14",
															 "16",
															 "18",
															 "20",
															 "22"});
			this.cbxFontSize.Location = new System.Drawing.Point(144, 245);
			this.cbxFontSize.Name = "cbxFontSize";
			this.cbxFontSize.Size = new System.Drawing.Size(72, 21);
			this.cbxFontSize.TabIndex = 8;
			// 
			// lblFontSize
			// 
			this.lblFontSize.Location = new System.Drawing.Point(13, 244);
			this.lblFontSize.Name = "lblFontSize";
			this.lblFontSize.Size = new System.Drawing.Size(64, 16);
			this.lblFontSize.TabIndex = 61;
			this.lblFontSize.Text = "Font Size";
			// 
			// lblMode
			// 
			this.lblMode.Location = new System.Drawing.Point(13, 71);
			this.lblMode.Name = "lblMode";
			this.lblMode.Size = new System.Drawing.Size(64, 17);
			this.lblMode.TabIndex = 57;
			this.lblMode.Text = "Mode";
			// 
			// chkHandleTilde
			// 
			this.chkHandleTilde.Location = new System.Drawing.Point(13, 97);
			this.chkHandleTilde.Name = "chkHandleTilde";
			this.chkHandleTilde.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.chkHandleTilde.Size = new System.Drawing.Size(147, 24);
			this.chkHandleTilde.TabIndex = 3;
			this.chkHandleTilde.Text = "Process Tilde";
			this.chkHandleTilde.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblECLevel
			// 
			this.lblECLevel.Location = new System.Drawing.Point(13, 132);
			this.lblECLevel.Name = "lblECLevel";
			this.lblECLevel.Size = new System.Drawing.Size(112, 24);
			this.lblECLevel.TabIndex = 64;
			this.lblECLevel.Text = "Error Correction Level (5% - 95%)";
			// 
			// chkSA
			// 
			this.chkSA.Location = new System.Drawing.Point(13, 162);
			this.chkSA.Name = "chkSA";
			this.chkSA.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.chkSA.Size = new System.Drawing.Size(147, 14);
			this.chkSA.TabIndex = 5;
			this.chkSA.Text = "Allow Structure Append";
			this.chkSA.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtECLevel
			// 
			this.txtECLevel.Location = new System.Drawing.Point(144, 133);
			this.txtECLevel.Name = "txtECLevel";
			this.txtECLevel.Size = new System.Drawing.Size(72, 20);
			this.txtECLevel.TabIndex = 4;
			this.txtECLevel.Text = "23";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(13, 192);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 16);
			this.label1.TabIndex = 68;
			this.label1.Text = "Current Symbol ID";
			// 
			// txtSymbolID
			// 
			this.txtSymbolID.Location = new System.Drawing.Point(144, 187);
			this.txtSymbolID.Name = "txtSymbolID";
			this.txtSymbolID.Size = new System.Drawing.Size(72, 20);
			this.txtSymbolID.TabIndex = 6;
			this.txtSymbolID.Text = "1";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(13, 218);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 16);
			this.label2.TabIndex = 70;
			this.label2.Text = "Total Symbols";
			// 
			// txtSymbolCount
			// 
			this.txtSymbolCount.Location = new System.Drawing.Point(144, 216);
			this.txtSymbolCount.Name = "txtSymbolCount";
			this.txtSymbolCount.Size = new System.Drawing.Size(72, 20);
			this.txtSymbolCount.TabIndex = 7;
			this.txtSymbolCount.Text = "26";
			// 
			// frmDemo
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(424, 430);
			this.Controls.Add(this.txtSymbolCount);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.txtSymbolID);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.txtECLevel);
			this.Controls.Add(this.chkSA);
			this.Controls.Add(this.lblECLevel);
			this.Controls.Add(this.chkHandleTilde);
			this.Controls.Add(this.txtAztec);
			this.Controls.Add(this.btnExit);
			this.Controls.Add(this.btnDisplay);
			this.Controls.Add(this.txtMessage);
			this.Controls.Add(this.lblMessage);
			this.Controls.Add(this.btnPrint);
			this.Controls.Add(this.cbxFontSize);
			this.Controls.Add(this.lblFontSize);
			this.Controls.Add(this.lblMode);
			this.Controls.Add(this.cbxPreferredFormat);
			this.Controls.Add(this.lblPF);
			this.Controls.Add(this.cbxMode);
			this.Name = "frmDemo";
			this.Text = "MW6 Aztec Font Demo";
			this.ResumeLayout(false);

			InitGUI();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmDemo());
		}

		private void InitGUI()
		{
			this.cbxFontSize.SelectedIndex = 6;
			this.cbxPreferredFormat.SelectedIndex = 0;
			this.cbxMode.SelectedIndex = 0;
		}

		private void btnPrint_Click(object sender, System.EventArgs e)
		{
			// Message 
			string Message = txtMessage.Text;

			// Mode
			int Mode = cbxMode.SelectedIndex;

			// Preferred Format
			int PreferredFormat = cbxPreferredFormat.SelectedIndex;

			// Error Correction Level
			int ECLevel = System.Convert.ToInt16(txtECLevel.Text);

			bool AllowStructuredAppend = chkSA.Checked;

			bool HandleTilde = chkHandleTilde.Checked;
	
			int SymbolID, SymbolCount; 
			if (AllowStructuredAppend) {
				SymbolID = System.Convert.ToInt16(txtSymbolID.Text);
				SymbolCount = System.Convert.ToInt16(txtSymbolCount.Text);
				AztecFontObj.SetStructuredAppend(SymbolID, SymbolCount);
			}

			// encode data using Aztec
			AztecFontObj.Encode(Message, Mode, ECLevel, PreferredFormat, HandleTilde, AllowStructuredAppend );

			// print Aztec barcode using Aztec font
			printDocument1.Print();
		}

		private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
		{
			// how many rows?
			int RowCount = AztecFontObj.GetRows();

			// how many characters in one row?
			int ColCount = AztecFontObj.GetCols();

			SolidBrush sb = new SolidBrush(Color.Black);
			Font fn = new Font("MW6 Matrix", System.Convert.ToInt16(cbxFontSize.Text), GraphicsUnit.Pixel);
			for (int i = 0; i <= (RowCount - 1); i++)
				// print one line using Aztec font
				e.Graphics.DrawString(AztecFontObj.GetRowStringAt(i), fn, sb, 10, 10 + i * fn.GetHeight());

			sb.Dispose();
			fn.Dispose();
		}

		private void btnDisplay_Click(object sender, System.EventArgs e)
		{
			// Message 
			string Message = txtMessage.Text;

			// Mode
			int Mode = cbxMode.SelectedIndex;

			// Preferred Format
			int PreferredFormat = cbxPreferredFormat.SelectedIndex;

			// Error Correction Level
			int ECLevel = System.Convert.ToInt16(txtECLevel.Text);

			bool AllowStructuredAppend = chkSA.Checked;

			bool HandleTilde = chkHandleTilde.Checked;
	
			int SymbolID, SymbolCount; 
			if (AllowStructuredAppend) 
			{
				SymbolID = System.Convert.ToInt16(txtSymbolID.Text);
				SymbolCount = System.Convert.ToInt16(txtSymbolCount.Text);
				AztecFontObj.SetStructuredAppend(SymbolID, SymbolCount);
			}

			// Encode data using Aztec
			AztecFontObj.Encode(Message, Mode, ECLevel, PreferredFormat, HandleTilde, AllowStructuredAppend );

			// How many rows?
			int RowCount = AztecFontObj.GetRows();

			// Produce string for Aztec font
			string EncodedMsg = "" + System.Convert.ToChar(13) + System.Convert.ToChar(10);
			for (int i = 0; i < RowCount; i++) {
				EncodedMsg = EncodedMsg + AztecFontObj.GetRowStringAt(i);
				EncodedMsg = EncodedMsg + System.Convert.ToChar(13) + System.Convert.ToChar(10);
			}

			txtAztec.Text = "";
			int FontSize = System.Convert.ToInt16(cbxFontSize.Text);
			txtAztec.Font = new Font("MW6 Matrix", FontSize, GraphicsUnit.Pixel);
			txtAztec.Text = EncodedMsg;
		}

		private void btnExit_Click(object sender, System.EventArgs e)
		{
			Application.Exit(); 
		}
	}
}